'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _avlTree = require('./lib/avlTree');

var _avlTree2 = _interopRequireDefault(_avlTree);

var _binarySearchTree = require('./lib/binarySearchTree');

var _binarySearchTree2 = _interopRequireDefault(_binarySearchTree);

var _graph = require('./lib/graph');

var _graph2 = _interopRequireDefault(_graph);

var _linkedList = require('./lib/linkedList');

var _linkedList2 = _interopRequireDefault(_linkedList);

var _matrix = require('./lib/matrix');

var _matrix2 = _interopRequireDefault(_matrix);

var _priorityQueue = require('./lib/priorityQueue');

var _priorityQueue2 = _interopRequireDefault(_priorityQueue);

var _queue = require('./lib/queue');

var _queue2 = _interopRequireDefault(_queue);

var _set = require('./lib/set');

var _set2 = _interopRequireDefault(_set);

var _stack = require('./lib/stack');

var _stack2 = _interopRequireDefault(_stack);

var _trie = require('./lib/trie');

var _trie2 = _interopRequireDefault(_trie);

var _vis = require('./vis/vis');

var _vis2 = _interopRequireDefault(_vis);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var jagu = {
  avlTree: _avlTree2.default,
  binarySearchTree: _binarySearchTree2.default,
  graph: _graph2.default,
  linkedList: _linkedList2.default,
  matrix: _matrix2.default,
  queue: _queue2.default,
  priorityQueue: _priorityQueue2.default,
  set: _set2.default,
  stack: _stack2.default,
  trie: _trie2.default
};

var isBrowser = new Function("try {return this===window;}catch(e){ return false;}");

if (isBrowser()) {
  jagu.vis = _vis2.default;
  window.jagu = jagu;
}

exports.default = jagu;