"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
/**
 * datastructures-js/stack
 * @copyright 2018 Eyas Ranjous <eyas.ranjous@gmail.com>
 * @license MIT
 */

var stack = function stack() {
  var top = 0;
  var elements = [];

  /**
   * @returns {number}
   */
  var length = function length() {
    return top;
  };

  /**
   * @returns {boolean}
   */
  var isEmpty = function isEmpty() {
    return top === 0;
  };

  /**
   * @param {object} el
   */
  var push = function push(el) {
    elements.push(el);
    top += 1;
  };

  /**
   * removes popped elements only when reaching half the stack
   * to improve performance for high frequency data
   */
  var removedPopped = function removedPopped() {
    if (top * 2 <= elements.length) {
      elements = elements.slice(0, top);
    }
  };

  /**
   * @returns {object}
   */
  var pop = function pop() {
    if (!isEmpty()) {
      top -= 1;
      var last = elements[top];
      removedPopped();
      return last;
    }
    return null;
  };

  /**
   * @returns {object}
   */
  var peek = function peek() {
    if (!isEmpty()) {
      return elements[top - 1];
    }
    return null;
  };

  /**
   * clears the stack
   */
  var clear = function clear() {
    top = 0;
    elements = [];
  };

  var getDataType = function getDataType() {
    return dataType;
  };

  var toArray = function toArray() {
    return elements.slice(0, top);
  };

  // stack api
  return {
    length: length,
    isEmpty: isEmpty,
    push: push,
    pop: pop,
    peek: peek,
    clear: clear,
    getDataType: getDataType,
    toArray: toArray
  };
};

exports.default = stack;