'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
/**
 * @copyright 2019 ChoWonmin <0108257@gmail.com>
 * @license MIT
 * @description util for draw and move d3 object
 */

var util = function util() {

  var drawShape = function drawShape(renderer, x, y, text) {
    var properties = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : {};
    var shape = arguments.length > 5 && arguments[5] !== undefined ? arguments[5] : 'rect';

    var props = {
      width: properties.width || 140,
      height: properties.height || 30,
      color: properties.color || '#ff6f74',
      fontColor: properties.fontColor || '#dedede'
    };

    var box = {
      rect: undefined,
      text: undefined
    };

    box.rect = root.append(shape).attr('x', x).attr('y', y).attr('width', props.width - 2 * props.padding).attr('height', props.height).attr('fill', props.color).attr('opacity', 1);

    box.text = root.append('text').attr('x', x + props.width / 2).attr('y', y + props.height / 2).attr('fill', props.fontColor).attr('alignment-baseline', 'middle').text(text);

    return box;
  };

  var move = function move(shape, x, y) {
    var transition = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : {};

    var transitionProps = {
      duration: transition || 700
    };

    shape.rect.transition().duration(transitionProps.duration).attr('x', x).attr('y', y);

    shape.text.transition().duration(transitionProps.duration).attr('x', x).attr('y', y + props.height / 2).on('end', function () {
      draw();
    });
  };

  var syncronize = function syncronize(lock, func) {
    if (!lock) {
      lock = true;
      func();
      lock = false;
    }
  };

  return {
    drawShape: drawShape,
    move: move,
    syncronize: syncronize
  };
};

exports.default = util();