'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _d = require('d3');

var d3 = _interopRequireWildcard(_d);

var _stackVis = require('./lib/stackVis');

var _stackVis2 = _interopRequireDefault(_stackVis);

var _queueVis = require('./lib/queueVis');

var _queueVis2 = _interopRequireDefault(_queueVis);

var _priorityQueueVis = require('./lib/priorityQueueVis');

var _priorityQueueVis2 = _interopRequireDefault(_priorityQueueVis);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

/**
 * @copyright 20109 ChoWonmin <0108257@gmail.com>
 * @license MIT
 * @description datastructure visualization library
 * @param {String} [renderer] html svg tag
 * @param {Object} [datastructure] jagu datastructure
 */

var isBrowser = new Function("try {return this===window;}catch(e){ return false;}");

var vis = null;

if (isBrowser()) {
  window.d3 = d3;
  vis = function vis(render, datastructure) {

    var renderer = d3.select(render);
    var data = datastructure;

    var stack = function stack() {
      return (0, _stackVis2.default)(renderer, data);
    };
    var queue = function queue() {
      return (0, _queueVis2.default)(renderer, data);
    };
    var priorityQueue = function priorityQueue() {
      return (0, _priorityQueueVis2.default)(renderer, data);
    };

    return {
      stack: stack,
      queue: queue,
      priorityQueue: priorityQueue
    };
  };
}

exports.default = vis;